/////////////////////////////////////////////////////////
//  FPShud v1.3                                        //
//  |eX|DEbig3 - 4/7/01                                //
//  Modified last: 4/10/01                             //
//  Displays a small hud with your current framerate.  //
/////////////////////////////////////////////////////////

function updateFPShud() {
	FPShud.fpsthing.setValue($fps::real);
	if ($FPShudToggle)
		schedule(500, 0, updateFPShud);
}

function makeFPShud() {
	$FPShudPosY = getword($pref::Video::resolution, 1) - 80;
	$FPShudPosX = 0;
	$FPShudPos = $FPShudPosX @ " " @ $FPShudPosY;
	$FPShud = new ShellFieldCtrl(FPShud) { // adds a new hud, i guess
		profile = "GuiChatBackProfile"; // look belowz0r
		horizSizing = "right"; // dunno
		vertSizing = "bottom"; // ""
		position = $FPShudPos; // *shrug*
		extent = "50 16"; // size
		minExtent = "8 8";  // *shrug*
		visible = "1"; // makes it visible
	};
	playgui.add($FPShud); // adds the hud to playgui (vge)
	FPShud.fpsthing = new GuiTextCtrl() { // adds a text control
		profile = "GuiTextObjHudCenterProfile"; // decides what the thing looks like i think
		horizSizing = "right"; // i dont understand this stuff
		vertSizing = "bottom"; // ""
		position = "0 3"; // ""
		extent = "50 16 "; // pretty simple methinks
		visible = "1"; // makes it visible, vge
	};
	FPShud.add(FPShud.fpsthing); // the text control goes in the hud, so we add it to the hud 
	updateFPShud();
}

function FPShudToggle( %val ) {
	if ( %val ) {
		if ($FPShudToggle) {
			$FPShudToggle = false;
			FPShud.visible = "0";
		}
		else {
			$FPShudToggle = true;
			FPShud.visible = "1";
			updateFPShud();
		}
	}
}

package FPShudLoad { // makes a package so i can do the loading thingy
	function LoadingGui::onWake( %this ) {
		makeFPShud(); // makes the hud
		parent::onWake(%this); // calls the original
	}
	
	function OptionsDlg::onWake( %this ) {
		if($FPShudToggleBind $= "false") {
			$RemapName[$RemapCount]="FPShud Toggle";
			$RemapCmd[$RemapCount]="FPShudToggle";
			$RemapCount++;
			$FPShudToggleBind = "true";
		}
		parent::onWake( %this );
	}
	
	function PlayGui::onWake( %this ) {
		parent::onWake( %this );
		$resolution = getword($pref::Video:resolution, 0);
		if ($resolution == 640)
			FPShud.position = "0 400";
		else if ($resolution == 800)
			FPShud.position = "0 520";
		else if ($resolution == 1024)
			FPShud.position = "0 688";
		else if ($resolution == 1280)
			FPShud.position = "0 880";
		else if ($resolution == 1600)
			FPShud.position = "0 1120";
	}
}; // closes the package

activatePackage(FPShudLoad);
$FPShudToggleBind = "false";
$FPShudToggle = true;